function PP=evaluate_SOP(F,XF,f,len)
% 
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2011   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for Boosting Algorithms for Simultaneous Feature Extraction and 
% Selection for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for TaylorBoost, SOPBoost and 
% POSBoost into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR TAYLOR, SOP, POS - BOOST
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR TAYLOR, SOP, POS BOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FORTAYLOR, SOP, POS BOOST WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
m=length(len);
S=zeros(1,size(XF,1));
if m==0
    PP=S;
else
    for i=1:m
        S1=ones(size(XF,1),1);
        for j=1:len(i)
            Hist=XF*f(:,F(i,j).num);
            %         u=Hist-F(j,i).thr;
            %         ru=(u>=(0))-(u < (0));
            %         S1=S1+(F(j,i).c)*ru+F(j,i).b;
            S1=S1.*((F(i,j).a)*Hist+F(i,j).b);
        end
        PP(i,:)=S1;
    end
end