function [Up,fx]=findbestmatlab(J,w,XF,f,step)
% 
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2011   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for Boosting Algorithms for Simultaneous Feature Extraction and 
% Selection for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for TaylorBoost, SOPBoost and 
% POSBoost into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR TAYLOR, SOP, POS - BOOST
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR TAYLOR, SOP, POS BOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FORTAYLOR, SOP, POS BOOST WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dd=size(f,2);
 
% n=sum(w);
for i=1:step:dd
    Hist=XF*f(:,i);
    Hist=Hist';
    A=sum(w.*(Hist.^2));
    B=sum(w.*Hist);
    CC=sum(w);
     
    E=sum(w.*J.*Hist);
    F=sum(w.*J);
    u=1/(A*CC-B^2+.000001);
    r1(i)=u*(E*CC-B*F);
    r2(i)=u*(-B*E+A*F);
    JJ=Hist*r1(i)+r2(i);
%     Loss(i)=sum(w.*((JJ-J).^2));
    NLoss(i)=((sum(w.*JJ.*J))^2)/(sum(w.*JJ.*JJ));
%     dgn(i)=sum(2*Y'.*JJ.*exp(-2*Y'.*a)./(1+exp(-2*Y'.*a)))/18000;
%     ang(i)=acosd(sum(JJ.*J)/(norm(J,2)*norm(JJ,2)));
end
%==========================================================================
% Loss=Loss+(Loss==0)*100000000000000;
% [p,q]=min(Loss);
[p,q]=max(NLoss);
% q=floor(rand(1)*length(Loss))+1;


Hist=XF*f(:,q);
fx= Hist*r1(q)+r2(q);
fx=fx';

Up.num=q;
Up.a=r1(q);
Up.b=r2(q);
Up.itr=1;
% Up.d=0;
